# -*- coding: utf-8 -*-

from PyQt5.QtWidgets import QMessageBox
import os
import sys
#import pyodbc


pluginPath = os.path.dirname(__file__)
sys.path.append(pluginPath)

class DB_Info:
    def __init__(self, iface):
        self.iface=iface  
        self.lyr = self.iface.activeLayer()
    
    def getDBinfo(self):
        self.db_connectInfo = {
            "Type":             self.lyr.providerType(),
            "User":             self.lyr.dataProvider().uri().username(),
            "Pwd":              self.lyr.dataProvider().uri().password(),
            "Server":           self.lyr.dataProvider().uri().host(),
            "Schema":           self.lyr.dataProvider().uri().schema(),
            "Database":         self.lyr.dataProvider().uri().database(),
            "Table":            self.lyr.dataProvider().uri().table()
            }
        # in the future support for self.lyr.dataProvider().uri().keyColumn() is expected
        
        ## since Primary Key columns are not identified via uri, SQL Server is used
        ## note: fid == pkey, hence following code not neccessary
        # cnxn = pyodbc.connect("Driver={SQL Server Native Client 11.0};"
        #         f"Server={self.db_connectInfo['Server']};"
        #         f"Database={self.db_connectInfo['Database']};"
        #         "Trusted_Connection=yes;")        
        # cursor = cnxn.cursor()
        #
        # SQLquery = f"""SELECT COLUMN_NAME
        #         FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE
        #         WHERE OBJECTPROPERTY(OBJECT_ID(CONSTRAINT_SCHEMA + '.' + QUOTENAME(CONSTRAINT_NAME)), 'IsPrimaryKey') = 1
        #         AND TABLE_NAME = '{self.db_connectInfo['Table']}' AND TABLE_SCHEMA = '{self.db_connectInfo['Schema']}'"""
        
        # cursor.execute(SQLquery)

        # self.db_connectInfo['PKEY'] = None
        # for row in cursor:
        #     self.db_connectInfo['PKEY'] = str(row[0])
        
        # if not self.db_connectInfo['PKEY']:
        #     QMessageBox.information(None,"Information", "Datentabelle hat keinen Primärschlüssel. Es wird versucht über die feature-id abzufragen ...")

        ## get features
        n_features = 0
        idStringList = ''
        idList = []
        for ft in self.lyr.getSelectedFeatures():
            # if self.db_connectInfo['PKEY']:
            #     n_features += 1
            #     idStringList += str(ft[self.db_connectInfo['PKEY']]) + ', '
            #     idList.append(ft[self.db_connectInfo['PKEY']])
            # else:
            n_features += 1
            idStringList += str(ft.id()) + ', '
            idList.append(ft.id())

        if n_features > 0:
            idStringList = idStringList[:-2]
            self.db_connectInfo['featureCount'] = n_features
            self.db_connectInfo['featureStringList'] = idStringList
            self.db_connectInfo['featureList'] = idList
        else:
            self.db_connectInfo['featureCount'] = n_features
            self.db_connectInfo['featureStringList'] = None
            self.db_connectInfo['featureList'] = None
    
        return self.db_connectInfo
        